import { head, is } from '../fn.js'
import { map, maybe, seq } from '../parser.js'
import { matchClause } from './match.js'
import { returnClause } from './return.js'
import { Query, SelectedGraph } from './types.js'
import { useClause } from './use.js'

const collect = args => {
  return args
  if (is(SelectedGraph, head(args))) {
    return new Query(...args)
  } else {
    return new Query(undefined, ...args)
  }
}

export const query = map(
  collect,
  seq(
    maybe(useClause),
    matchClause,
    returnClause
  )
)

